diff --git a/app/proc-info/main.c b/app/proc-info/main.c
index b7e70b4bf5..dd481e26b8 100644
--- a/app/proc-info/main.c
+++ b/app/proc-info/main.c
@@ -49,6 +49,9 @@
 #define STATS_BDR_STR(w, s) printf("%.*s%s%.*s\n", w, \
 	STATS_BDR_FMT, s, w, STATS_BDR_FMT)
 
+typedef int (*desc_dump_t)(FILE *file, uint16_t port_id, uint16_t queue_id,
+			    uint16_t desc_id);
+
 /**< mask of enabled ports */
 static unsigned long enabled_port_mask;
 /**< Enable stats. */
@@ -107,6 +110,12 @@ static uint32_t enable_shw_version;
 static uint32_t enable_shw_rss_reta;
 /**< Enable show module info. */
 static uint32_t enable_shw_module_info;
+/**< Enable dump buffer descriptor. */
+#define MAX_NB_ITEM 2
+static uint16_t rx_nb_item;
+static uint16_t tx_nb_item;
+static uint16_t rx_item_opt[MAX_NB_ITEM];
+static uint16_t tx_item_opt[MAX_NB_ITEM];
 
 /**< display usage */
 static void
@@ -137,6 +146,8 @@ proc_info_usage(const char *prgname)
 		"  --show-version: to display DPDK version and firmware version\n"
 		"  --show-rss-reta: to display ports redirection table\n"
 		"  --show-module-info: to display ports module info\n"
+		"  --show-rx-descriptor queue_id:descriptor_id: to display ports Rx buffer description by queue id and descriptor id\n"
+		"  --show-tx-descriptor queue_id:descriptor_id: to display ports Tx buffer description by queue id and descriptor id\n"
 		"  --iter-mempool=name: iterate mempool elements to display content\n"
 		"  --dump-regs=file-prefix: dump registers to file with the file-prefix\n",
 		prgname);
@@ -189,6 +200,34 @@ parse_xstats_ids(char *list, uint64_t *ids, int limit) {
 	return length;
 }
 
+/*
+ * Parse ids value list into array
+ */
+static int
+parse_descriptor_param(char *list, uint16_t *item_opt, int limit)
+{
+	int length;
+	char *token;
+	char *ctx = NULL;
+	char *endptr;
+
+	length = 0;
+	token = strtok_r(list, ":", &ctx);
+	while (token != NULL) {
+		item_opt[length] = strtoul(token, &endptr, 10);
+		if (*endptr != '\0')
+			return -EINVAL;
+
+		length++;
+		if (length > limit)
+			return -E2BIG;
+
+		token = strtok_r(NULL, ":", &ctx);
+	}
+
+	return length;
+}
+
 static int
 proc_info_preparse_args(int argc, char **argv)
 {
@@ -251,6 +290,8 @@ proc_info_parse_args(int argc, char **argv)
 		{"show-version", 0, NULL, 0},
 		{"show-rss-reta", 0, NULL, 0},
 		{"show-module-info", 0, NULL, 0},
+		{"show-rx-descriptor", required_argument, NULL, 1},
+		{"show-tx-descriptor", required_argument, NULL, 1},
 		{NULL, 0, 0, 0}
 	};
 
@@ -348,6 +389,26 @@ proc_info_parse_args(int argc, char **argv)
 					return -1;
 				}
 				nb_xstats_ids = ret;
+			} else if (!strncmp(long_option[option_index].name,
+				"show-rx-descriptor", MAX_LONG_OPT_SZ)) {
+				int ret = parse_descriptor_param(optarg,
+								 rx_item_opt,
+								 MAX_NB_ITEM);
+				if (ret < MAX_NB_ITEM) {
+					printf("Rx descriptor param parse error.\n");
+					return -1;
+				}
+				rx_nb_item = ret;
+			} else if (!strncmp(long_option[option_index].name,
+				"show-tx-descriptor", MAX_LONG_OPT_SZ)) {
+				int ret = parse_descriptor_param(optarg,
+								 tx_item_opt,
+								 MAX_NB_ITEM);
+				if (ret < MAX_NB_ITEM) {
+					printf("Tx descriptor param parse error.\n");
+					return -1;
+				}
+				tx_nb_item = ret;
 			}
 			break;
 		default:
@@ -1597,6 +1658,20 @@ static void show_module_eeprom_info(void)
 	}
 }
 
+static void
+nic_descriptor_display(uint16_t port_id, uint16_t *item_opt,
+		       desc_dump_t desc_dump)
+{
+	static const char *nic_desc_border = "###";
+	uint16_t queue_id = item_opt[0];
+	uint16_t desc_id = item_opt[1];
+
+	printf("%s NIC descriptor for port %u %s\n",
+		   nic_desc_border, port_id, nic_desc_border);
+
+	desc_dump(stdout, port_id, queue_id, desc_id);
+}
+
 int
 main(int argc, char **argv)
 {
@@ -1680,6 +1755,12 @@ main(int argc, char **argv)
 		else if (nb_xstats_ids > 0)
 			nic_xstats_by_ids_display(i, xstats_ids,
 						  nb_xstats_ids);
+		else if (rx_nb_item > 0)
+			nic_descriptor_display(i, rx_item_opt,
+					       rte_eth_rx_hw_desc_dump);
+		else if (tx_nb_item > 0)
+			nic_descriptor_display(i, tx_item_opt,
+					       rte_eth_tx_hw_desc_dump);
 #ifdef RTE_LIB_METRICS
 		else if (enable_metrics)
 			metrics_display(i);